import Vue from 'vue';

/*! *****************************************************************************
Copyright (c) Microsoft Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0

THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.

See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */
/* global Reflect, Promise */

var extendStatics = function(d, b) {
    extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return extendStatics(d, b);
};

function __extends(d, b) {
    extendStatics(d, b);
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
}

function __decorate(decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
}

function unwrapExports (x) {
	return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, 'default') ? x.default : x;
}

function createCommonjsModule(fn, module) {
	return module = { exports: {} }, fn(module, module.exports), module.exports;
}

var vueClassComponent_common = createCommonjsModule(function (module, exports) {

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var Vue$$1 = _interopDefault(Vue);

var reflectionIsSupported = typeof Reflect !== 'undefined' && Reflect.defineMetadata;
function copyReflectionMetadata(to, from) {
    forwardMetadata(to, from);
    Object.getOwnPropertyNames(from.prototype).forEach(function (key) {
        forwardMetadata(to.prototype, from.prototype, key);
    });
    Object.getOwnPropertyNames(from).forEach(function (key) {
        forwardMetadata(to, from, key);
    });
}
function forwardMetadata(to, from, propertyKey) {
    var metaKeys = propertyKey
        ? Reflect.getOwnMetadataKeys(from, propertyKey)
        : Reflect.getOwnMetadataKeys(from);
    metaKeys.forEach(function (metaKey) {
        var metadata = propertyKey
            ? Reflect.getOwnMetadata(metaKey, from, propertyKey)
            : Reflect.getOwnMetadata(metaKey, from);
        if (propertyKey) {
            Reflect.defineMetadata(metaKey, metadata, to, propertyKey);
        }
        else {
            Reflect.defineMetadata(metaKey, metadata, to);
        }
    });
}

var fakeArray = { __proto__: [] };
var hasProto = fakeArray instanceof Array;
function createDecorator(factory) {
    return function (target, key, index) {
        var Ctor = typeof target === 'function'
            ? target
            : target.constructor;
        if (!Ctor.__decorators__) {
            Ctor.__decorators__ = [];
        }
        if (typeof index !== 'number') {
            index = undefined;
        }
        Ctor.__decorators__.push(function (options) { return factory(options, key, index); });
    };
}
function mixins() {
    var Ctors = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        Ctors[_i] = arguments[_i];
    }
    return Vue$$1.extend({ mixins: Ctors });
}
function isPrimitive(value) {
    var type = typeof value;
    return value == null || (type !== 'object' && type !== 'function');
}
function warn(message) {
    if (typeof console !== 'undefined') {
        console.warn('[vue-class-component] ' + message);
    }
}

function collectDataFromConstructor(vm, Component) {
    // override _init to prevent to init as Vue instance
    var originalInit = Component.prototype._init;
    Component.prototype._init = function () {
        var _this = this;
        // proxy to actual vm
        var keys = Object.getOwnPropertyNames(vm);
        // 2.2.0 compat (props are no longer exposed as self properties)
        if (vm.$options.props) {
            for (var key in vm.$options.props) {
                if (!vm.hasOwnProperty(key)) {
                    keys.push(key);
                }
            }
        }
        keys.forEach(function (key) {
            if (key.charAt(0) !== '_') {
                Object.defineProperty(_this, key, {
                    get: function () { return vm[key]; },
                    set: function (value) { vm[key] = value; },
                    configurable: true
                });
            }
        });
    };
    // should be acquired class property values
    var data = new Component();
    // restore original _init to avoid memory leak (#209)
    Component.prototype._init = originalInit;
    // create plain data object
    var plainData = {};
    Object.keys(data).forEach(function (key) {
        if (data[key] !== undefined) {
            plainData[key] = data[key];
        }
    });
    if (process.env.NODE_ENV !== 'production') {
        if (!(Component.prototype instanceof Vue$$1) && Object.keys(plainData).length > 0) {
            warn('Component class must inherit Vue or its descendant class ' +
                'when class property is used.');
        }
    }
    return plainData;
}

var $internalHooks = [
    'data',
    'beforeCreate',
    'created',
    'beforeMount',
    'mounted',
    'beforeDestroy',
    'destroyed',
    'beforeUpdate',
    'updated',
    'activated',
    'deactivated',
    'render',
    'errorCaptured' // 2.5
];
function componentFactory(Component, options) {
    if (options === void 0) { options = {}; }
    options.name = options.name || Component._componentTag || Component.name;
    // prototype props.
    var proto = Component.prototype;
    Object.getOwnPropertyNames(proto).forEach(function (key) {
        if (key === 'constructor') {
            return;
        }
        // hooks
        if ($internalHooks.indexOf(key) > -1) {
            options[key] = proto[key];
            return;
        }
        var descriptor = Object.getOwnPropertyDescriptor(proto, key);
        if (descriptor.value !== void 0) {
            // methods
            if (typeof descriptor.value === 'function') {
                (options.methods || (options.methods = {}))[key] = descriptor.value;
            }
            else {
                // typescript decorated data
                (options.mixins || (options.mixins = [])).push({
                    data: function () {
                        var _a;
                        return _a = {}, _a[key] = descriptor.value, _a;
                    }
                });
            }
        }
        else if (descriptor.get || descriptor.set) {
            // computed properties
            (options.computed || (options.computed = {}))[key] = {
                get: descriptor.get,
                set: descriptor.set
            };
        }
    });
    (options.mixins || (options.mixins = [])).push({
        data: function () {
            return collectDataFromConstructor(this, Component);
        }
    });
    // decorate options
    var decorators = Component.__decorators__;
    if (decorators) {
        decorators.forEach(function (fn) { return fn(options); });
        delete Component.__decorators__;
    }
    // find super
    var superProto = Object.getPrototypeOf(Component.prototype);
    var Super = superProto instanceof Vue$$1
        ? superProto.constructor
        : Vue$$1;
    var Extended = Super.extend(options);
    forwardStaticMembers(Extended, Component, Super);
    if (reflectionIsSupported) {
        copyReflectionMetadata(Extended, Component);
    }
    return Extended;
}
var reservedPropertyNames = [
    // Unique id
    'cid',
    // Super Vue constructor
    'super',
    // Component options that will be used by the component
    'options',
    'superOptions',
    'extendOptions',
    'sealedOptions',
    // Private assets
    'component',
    'directive',
    'filter'
];
function forwardStaticMembers(Extended, Original, Super) {
    // We have to use getOwnPropertyNames since Babel registers methods as non-enumerable
    Object.getOwnPropertyNames(Original).forEach(function (key) {
        // `prototype` should not be overwritten
        if (key === 'prototype') {
            return;
        }
        // Some browsers does not allow reconfigure built-in properties
        var extendedDescriptor = Object.getOwnPropertyDescriptor(Extended, key);
        if (extendedDescriptor && !extendedDescriptor.configurable) {
            return;
        }
        var descriptor = Object.getOwnPropertyDescriptor(Original, key);
        // If the user agent does not support `__proto__` or its family (IE <= 10),
        // the sub class properties may be inherited properties from the super class in TypeScript.
        // We need to exclude such properties to prevent to overwrite
        // the component options object which stored on the extended constructor (See #192).
        // If the value is a referenced value (object or function),
        // we can check equality of them and exclude it if they have the same reference.
        // If it is a primitive value, it will be forwarded for safety.
        if (!hasProto) {
            // Only `cid` is explicitly exluded from property forwarding
            // because we cannot detect whether it is a inherited property or not
            // on the no `__proto__` environment even though the property is reserved.
            if (key === 'cid') {
                return;
            }
            var superDescriptor = Object.getOwnPropertyDescriptor(Super, key);
            if (!isPrimitive(descriptor.value) &&
                superDescriptor &&
                superDescriptor.value === descriptor.value) {
                return;
            }
        }
        // Warn if the users manually declare reserved properties
        if (process.env.NODE_ENV !== 'production' &&
            reservedPropertyNames.indexOf(key) >= 0) {
            warn("Static property name '" + key + "' declared on class '" + Original.name + "' " +
                'conflicts with reserved property name of Vue internal. ' +
                'It may cause unexpected behavior of the component. Consider renaming the property.');
        }
        Object.defineProperty(Extended, key, descriptor);
    });
}

function Component(options) {
    if (typeof options === 'function') {
        return componentFactory(options);
    }
    return function (Component) {
        return componentFactory(Component, options);
    };
}
Component.registerHooks = function registerHooks(keys) {
    $internalHooks.push.apply($internalHooks, keys);
};

exports.default = Component;
exports.createDecorator = createDecorator;
exports.mixins = mixins;
});

var Component = unwrapExports(vueClassComponent_common);
var vueClassComponent_common_1 = vueClassComponent_common.createDecorator;
var vueClassComponent_common_2 = vueClassComponent_common.mixins;

var VueAriaInterface = Vue.extend({
    props: {
        role: String,
        aria: [Object, Array],
        tabindex: Number
    }
});
/**
 * <VueAria role aria tabindex>
 * - props: role, aria, tabindex
 * - slots: default slot
 */
var VueAria = /** @class */ (function (_super) {
    __extends(VueAria, _super);
    function VueAria() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    VueAria = __decorate([
        Component({
            render: function (h) {
                var _a = this, role = _a.role, aria = _a.aria, tabindex = _a.tabindex;
                var rootVNode = this.$slots["default"][0];
                if (rootVNode) {
                    if (!rootVNode.data) {
                        rootVNode.data = {};
                    }
                    if (!rootVNode.data.attrs) {
                        rootVNode.data.attrs = {};
                    }
                    var attrs = rootVNode.data.attrs;
                    // set `role`
                    if (role) {
                        attrs.role = role;
                    }
                    // set `tabindex`
                    mergeTabindexToVNode(attrs, tabindex);
                    // set `aria-*`
                    mergeAriaAttrsToVNode(attrs, aria);
                }
                return rootVNode;
            }
        })
    ], VueAria);
    return VueAria;
}(VueAriaInterface));
/**
 * <Foo v-aria>
 */
var directiveAria = {
    inserted: function (el, _a) {
        var value = _a.value, oldValue = _a.oldValue;
        mergeAriaAttrsToElement(el, value, oldValue);
    },
    update: function (el, _a) {
        var value = _a.value, oldValue = _a.oldValue;
        mergeAriaAttrsToElement(el, value, oldValue);
    }
};
// merging functions
function mergeTabindexToVNode(attrs, tabindex) {
    if (attrs) {
        var isAppearance = attrs.role === "none" || attrs.role === "appearance";
        if (typeof tabindex !== "number" || isNaN(tabindex)) {
            // no value passed in
            if (isAppearance) {
                attrs.tabindex = "";
            }
        }
        else {
            // a number passed in
            attrs.tabindex = tabindex.toString();
        }
    }
}
function mergeAriaAttrsToVNode(attrs, aria) {
    if (attrs) {
        var flatAria = flattenAria(aria);
        for (var name in flatAria) {
            var value = flatAria[name];
            if (isValidAttributeValue(value)) {
                attrs["aria-" + name] = value.toString();
            }
            else {
                delete attrs["aria-" + name];
            }
        }
    }
}
function mergeAriaAttrsToElement(el, aria, oldAria) {
    var flatAria = flattenAria(aria);
    var flatOldAria = flattenAria(oldAria);
    // 1. find attributes in value but not in oldValue and remove them
    for (var name in flatOldAria) {
        if (!isValidAttributeValue(flatAria[name]) &&
            isValidAttributeValue(flatOldAria[name])) {
            el.removeAttribute("aria-" + name);
        }
    }
    // 2. set all attributes in value
    for (var name in flatAria) {
        var value = flatAria[name];
        if (isValidAttributeValue(value)) {
            el.setAttribute("aria-" + name, value.toString());
        }
    }
}
// util functions
function flattenAria(aria) {
    var result = {};
    if (aria) {
        if (Array.isArray(aria)) {
            aria.forEach(function (ariaItem) {
                Object.assign(result, ariaItem);
            });
        }
        else {
            Object.assign(result, aria);
        }
    }
    return result;
}
function isValidAttributeValue(value) {
    if (typeof value === "undefined") {
        return false;
    }
    if (value === null) {
        return false;
    }
    return true;
}

var VueFocusTrapInterface = Vue.extend({
    props: {
        disabled: Boolean
    }
});
/**
 * <VueFocusTrap disabled>
 * - props: disabled
 * - events: gofirst, golast
 * - slots: default slot
 */
var VueFocusTrap = /** @class */ (function (_super) {
    __extends(VueFocusTrap, _super);
    function VueFocusTrap() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    VueFocusTrap.prototype.trapFocus = function (event) {
        if (this.disabled) {
            return;
        }
        var root = this.$el;
        var _a = this.$refs, start = _a.start, end = _a.end;
        var target = event.target;
        if (!root.contains(target)) {
            event.preventDefault();
            this.$emit("gofirst");
        }
        else if (target === start) {
            event.preventDefault();
            this.$emit("golast");
        }
        else if (target === end) {
            event.preventDefault();
            this.$emit("gofirst");
        }
    };
    VueFocusTrap = __decorate([
        Component({
            data: function () {
                return {
                    mounted: false
                };
            },
            mounted: function () {
                this.mounted = true;
                document.addEventListener("focus", this.trapFocus, true);
            },
            beforeDestroy: function () {
                if (this.mounted) {
                    document.removeEventListener("focus", this.trapFocus, true);
                }
            }
        })
    ], VueFocusTrap);
    return VueFocusTrap;
}(VueFocusTrapInterface));

/* script */
            const __vue_script__ = VueFocusTrap;
            
/* template */
var __vue_render__ = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',[_c('div',{ref:"start",attrs:{"tabindex":"0"}}),_vm._v(" "),_vm._t("default"),_vm._v(" "),_c('div',{ref:"end",attrs:{"tabindex":"0"}})],2)};
var __vue_staticRenderFns__ = [];

  /* style */
  const __vue_inject_styles__ = undefined;
  /* scoped */
  const __vue_scope_id__ = undefined;
  /* module identifier */
  const __vue_module_identifier__ = undefined;
  /* functional template */
  const __vue_is_functional_template__ = false;
  /* component normalizer */
  function __vue_normalize__(
    template, style, script,
    scope, functional, moduleIdentifier,
    createInjector, createInjectorSSR
  ) {
    const component = (typeof script === 'function' ? script.options : script) || {};

    // For security concerns, we use only base name in production mode.
    component.__file = "focus-trap.vue";

    if (!component.render) {
      component.render = template.render;
      component.staticRenderFns = template.staticRenderFns;
      component._compiled = true;

      if (functional) component.functional = true;
    }

    component._scopeId = scope;

    return component
  }
  /* style inject */
  
  /* style inject SSR */
  

  
  var focusTrap = __vue_normalize__(
    { render: __vue_render__, staticRenderFns: __vue_staticRenderFns__ },
    __vue_inject_styles__,
    __vue_script__,
    __vue_scope_id__,
    __vue_is_functional_template__,
    __vue_module_identifier__,
    undefined,
    undefined
  );

function capitalizeFirstLetter(str) {
    return str.charAt(0).toUpperCase() + str.slice(1);
}

var defaultKeyToMethod = {
    ArrowUp: "prev",
    ArrowDown: "next",
    ArrowLeft: "prev",
    ArrowRight: "next",
    Home: "first",
    End: "last",
    Enter: "action",
    Space: "action",
    " ": "action"
};
/**
 * Mixin: KeyTravel
 * - methods: keyTravel(event[, config])
 * work with:
 * - value: autofocus, orientation
 * - methods: getKeyItems()
 * could be overrided:
 * - methods: // call focus() or $el.focus() by default
 *            goPrev(), goNext(), goFirst(), goLast(),
 *            // focus first item in key items by default
 *            getAutofocusItem(),
 *            // nothing happen by default
 *            goNextPage(), goPrevPage(),
 *            // call fireAction(item) by default
 *            goAction()
 *            // call fireAction() in the item by default
 *            fireAction(item)
 */
var MixinKeyTravel = /** @class */ (function (_super) {
    __extends(MixinKeyTravel, _super);
    function MixinKeyTravel() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    // fixed
    MixinKeyTravel.prototype.keyTravel = function (event, config) {
        // get the current key
        var keyToMethod = Object.assign({}, defaultKeyToMethod, this.orientation === "vertical"
            ? {
                ArrowLeft: "",
                ArrowRight: ""
            }
            : {}, this.orientation === "horizontal"
            ? {
                ArrowUp: "",
                ArrowDown: ""
            }
            : {}, config);
        var methodName = keyToMethod[event.key] || "";
        // make sure what to do next
        if (methodName) {
            var method = this["go" + capitalizeFirstLetter(methodName)];
            if (typeof method === "function") {
                var willPreventDefault = method.call(this, event);
                if (willPreventDefault) {
                    event.preventDefault();
                }
            }
        }
    };
    // need be overrided
    MixinKeyTravel.prototype.getKeyItems = function () {
        return [];
    };
    // could be overrided
    MixinKeyTravel.prototype.fireAction = function (item) {
        return fireItemAction(item);
    };
    // could be overrided
    MixinKeyTravel.prototype.getAutofocusItem = function () {
        return this.getKeyItems()[0];
    };
    // could be overrided
    MixinKeyTravel.prototype.goPrev = function () {
        var items = this.getKeyItems();
        var length = items.length;
        if (length === 0) {
            return;
        }
        var activeIndex = getActiveIndex(items);
        var prevItem = activeIndex <= 0 ? items[length - 1] : items[activeIndex - 1];
        return focusItem(prevItem);
    };
    // could be overrided
    MixinKeyTravel.prototype.goNext = function () {
        var items = this.getKeyItems();
        var length = items.length;
        if (length === 0) {
            return;
        }
        var activeIndex = getActiveIndex(items);
        var nextItem = activeIndex === length - 1 ? items[0] : items[activeIndex + 1];
        return focusItem(nextItem);
    };
    // could be overrided
    MixinKeyTravel.prototype.goFirst = function () {
        var items = this.getKeyItems();
        var length = items.length;
        if (length === 0) {
            return;
        }
        var firstItem = items[0];
        if (!isActiveItem(firstItem)) {
            return focusItem(firstItem);
        }
    };
    // could be overrided
    MixinKeyTravel.prototype.goLast = function () {
        var items = this.getKeyItems();
        var length = items.length;
        if (length === 0) {
            return;
        }
        var lastItem = items[length - 1];
        if (!isActiveItem(lastItem)) {
            return focusItem(lastItem);
        }
    };
    // could be overrided
    MixinKeyTravel.prototype.goNextPage = function () { };
    // could be overrided
    MixinKeyTravel.prototype.goPrevPage = function () { };
    // could be overrided
    MixinKeyTravel.prototype.goAction = function () {
        var items = this.getKeyItems();
        var length = items.length;
        if (length === 0) {
            return;
        }
        var activeIndex = getActiveIndex(items);
        var activeItem = items[activeIndex];
        return this.fireAction(activeItem);
    };
    MixinKeyTravel = __decorate([
        Component({
            // fixed
            mounted: function () {
                if (this.autofocus) {
                    focusItem(this.getAutofocusItem());
                }
            }
        })
    ], MixinKeyTravel);
    return MixinKeyTravel;
}(Vue));
// focus functions
function getActiveIndex(items) {
    var activeIndex = -1;
    var activeElement = document.activeElement;
    items.some(function (item, index) {
        var el = item.$el ? item.$el : item;
        if (el === activeElement) {
            activeIndex = index;
            return true;
        }
        return false;
    });
    return activeIndex;
}
function isActiveItem(item) {
    if (!item) {
        return false;
    }
    var el = item.$el ? item.$el : item;
    return el === document.activeElement;
}
function focusItem(item) {
    if (item) {
        if (typeof item.focus === "function") {
            item.focus();
            return true;
        }
        if (item.$el && typeof item.$el.focus === "function") {
            item.$el.focus();
            return true;
        }
    }
}
function fireItemAction(item) {
    if (item && typeof item.fireAction === "function") {
        item.fireAction();
        return true;
    }
}

var MixinIdInterface = Vue.extend({
    props: {
        id: String
    }
});
/**
 * Mixin: Id
 * - prop: id
 * - data: localId
 */
var MixinId = /** @class */ (function (_super) {
    __extends(MixinId, _super);
    function MixinId() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Object.defineProperty(MixinId.prototype, "localId", {
        get: function () {
            return this.id || generateNewId();
        },
        enumerable: true,
        configurable: true
    });
    MixinId = __decorate([
        Component
    ], MixinId);
    return MixinId;
}(MixinIdInterface));
var lastId = Date.now();
function generateNewId() {
    var now = Date.now();
    if (now <= lastId) {
        lastId++;
    }
    else {
        lastId = now;
    }
    return "v-" + lastId;
}

/**
 * Mixin: KeyShortcuts
 * - option: shortcuts: Array<ShortcutConfig>
 * - methods: bindShortcut(KeyboardEvent, name)
 */
var MixinKeyShortcuts = /** @class */ (function (_super) {
    __extends(MixinKeyShortcuts, _super);
    function MixinKeyShortcuts() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    MixinKeyShortcuts.prototype.bindShortcut = function (event, name) {
        var _this = this;
        if (name === void 0) { name = "default"; }
        var target = event.currentTarget;
        if (!target) {
            return;
        }
        // update global unique key seq
        var updated = updateKeySeq(event, target);
        // match shortcuts
        if (updated) {
            // check whether end rule matched
            var touchedEndBefore = keyEventIsEnded(target);
            if (!touchedEndBefore) {
                var shortcuts = getShortcutsByName(this.$options.shortcuts, name);
                shortcuts.some(function (shortcut) {
                    // match new rules in current shortcut config
                    if (matchShortcut(shortcut, target)) {
                        // do the job and make sure whether to end the matching process
                        var ended = shortcut.handle.call(_this, event);
                        if (ended) {
                            endLastKeyDown(target);
                        }
                        return keyEventIsEnded(target);
                    }
                    return false;
                });
            }
        }
    };
    MixinKeyShortcuts = __decorate([
        Component({
            beforeMount: function () {
                if (this.$options.shortcuts) {
                    window.addEventListener("keydown", this.bindShortcut);
                }
            },
            beforeDestroy: function () {
                if (this.$options.shortcuts) {
                    window.removeEventListener("keydown", this.bindShortcut);
                }
            }
        })
    ], MixinKeyShortcuts);
    return MixinKeyShortcuts;
}(Vue));
var KeyDown = /** @class */ (function () {
    function KeyDown(name, modifiers) {
        if (modifiers === void 0) { modifiers = {}; }
        this.name = parseKeyName(name);
        var ctrl = modifiers.ctrl, shift = modifiers.shift, alt = modifiers.alt, meta = modifiers.meta, window = modifiers.window, cmd = modifiers.cmd, option = modifiers.option;
        this.ctrl = !!ctrl;
        this.shift = !!shift;
        this.alt = !!alt || !!option;
        this.meta = !!meta || !!window || !!cmd;
        this.timestamp = Date.now();
    }
    KeyDown.parseEvent = function (event) {
        var key = event.key, code = event.code, ctrlKey = event.ctrlKey, shiftKey = event.shiftKey, altKey = event.altKey, metaKey = event.metaKey;
        // skip modifier key
        if (["Control", "Shift", "Alt", "Meta"].indexOf(key) >= 0) {
            return;
        }
        var keyModifiers = {
            ctrl: ctrlKey,
            shift: shiftKey,
            alt: altKey,
            meta: metaKey
        };
        // number: key
        if (key.match(/^Digit\d$/)) {
            return new KeyDown(key, keyModifiers);
        }
        // alphabet: code
        if (code.match(/^Key\w$/)) {
            return new KeyDown(code, keyModifiers);
        }
        // navigation: key
        if ([
            "Up",
            "Down",
            "Left",
            "Right",
            "ArrowUp",
            "ArrowDown",
            "ArrowLeft",
            "ArrowRight",
            "Home",
            "End",
            "PageUp",
            "PageDown"
        ].indexOf(key) >= 0) {
            return new KeyDown(key, keyModifiers);
        }
        // other: code
        return new KeyDown(code, keyModifiers);
    };
    KeyDown.prototype.equals = function (keyDown) {
        if (!keyDown || typeof keyDown.toString !== "function") {
            return false;
        }
        return this.toString() === keyDown.toString();
    };
    KeyDown.prototype.toString = function () {
        var _this = this;
        var name = this.name;
        var modifiers = ["ctrl", "shift", "alt", "meta"]
            .filter(function (modifier) { return _this[modifier]; })
            .join(",");
        return modifiers ? name + "(" + modifiers + ")" : name;
    };
    return KeyDown;
}());
// keydown functions
function parseKeyName(name) {
    if (name.match(/^[a-z]$/)) {
        return "Key" + name.toUpperCase();
    }
    if (name.match(/^[0-9]$/)) {
        return "Digit" + name.toUpperCase();
    }
    var specialNameMap = {
        up: "ArrowUp",
        down: "ArrowDown",
        left: "ArrowLeft",
        right: "ArrowRight",
        home: "Home",
        end: "End",
        pagedown: "PageDown",
        pageup: "PageUp"
    };
    var specialName = specialNameMap[name.toLowerCase()];
    if (specialName) {
        return specialName;
    }
    return capitalizeFirstLetter(name);
}
// key shortcuts config functions
function getShortcutsByName(shortcutsOption, name) {
    if (name === void 0) { name = "default"; }
    if (Array.isArray(shortcutsOption)) {
        if (name === "default") {
            return shortcutsOption;
        }
        return [];
    }
    if (shortcutsOption) {
        var shortcuts = shortcutsOption[name];
        if (Array.isArray(shortcuts)) {
            return shortcuts;
        }
        else if (shortcuts) {
            return [shortcuts];
        }
        return [];
    }
    return [];
}
// key sequence functions
var maxKeySeqLength = 32;
var keySeqMap = new WeakMap();
function updateKeySeq(event, target) {
    var keySeq = keySeqMap.get(target) || [];
    if (!keySeqMap.has(target)) {
        keySeqMap.set(target, keySeq);
    }
    var keyDown = KeyDown.parseEvent(event);
    if (keyDown) {
        keySeq.push(keyDown);
        if (keySeq.length > maxKeySeqLength) {
            keySeq.shift();
        }
        return true;
    }
    return false;
}
function keyEventIsEnded(target) {
    var keySeq = keySeqMap.get(target) || [];
    if (!keySeqMap.has(target)) {
        keySeqMap.set(target, keySeq);
    }
    var lastKeyDown = keySeq[keySeq.length - 1];
    return lastKeyDown ? !!lastKeyDown.ended : false;
}
function matchShortcut(shortcut, target) {
    var keySeq = keySeqMap.get(target) || [];
    if (!keySeqMap.has(target)) {
        keySeqMap.set(target, keySeq);
    }
    var key = shortcut.key, keys = shortcut.keys, modifiers = shortcut.modifiers;
    var keyDownList = [];
    if (Array.isArray(keys)) {
        keyDownList.push.apply(keyDownList, keys
            .filter(function (descriptor) {
            return descriptor && (typeof descriptor === "string" || descriptor.key);
        })
            .map(function (descriptor) {
            if (typeof descriptor === "string") {
                return new KeyDown(descriptor);
            }
            return new KeyDown(descriptor.key, descriptor.modifiers);
        }));
    }
    else if (key) {
        keyDownList.push(new KeyDown(key, modifiers));
    }
    var keyDownListLength = keyDownList.length;
    var keySeqLength = keySeq.length;
    if (!keyDownListLength) {
        return false;
    }
    for (var index = 0; index < keyDownListLength; index++) {
        if (!keySeq[keySeqLength - 1 - index].equals(keyDownList[keyDownListLength - 1 - index])) {
            return false;
        }
    }
    return true;
}
function endLastKeyDown(target) {
    var keySeq = keySeqMap.get(target) || [];
    if (!keySeqMap.has(target)) {
        keySeqMap.set(target, keySeq);
    }
    var lastKeyDown = keySeq[keySeq.length - 1];
    if (lastKeyDown) {
        lastKeyDown.ended = true;
    }
}

var VueLiveInterface = Vue.extend({
    props: {
        role: String,
        label: String
    }
});
var VueLive = /** @class */ (function (_super) {
    __extends(VueLive, _super);
    function VueLive() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.assertiveMessage = "";
        _this.politeMessage = "";
        _this.busy = false;
        return _this;
    }
    Object.defineProperty(VueLive.prototype, "localRole", {
        get: function () {
            return this.role || "log";
        },
        enumerable: true,
        configurable: true
    });
    VueLive = __decorate([
        Component({
            components: { VueAria: VueAria },
            provide: function () {
                var self = this;
                return {
                    announce: function (message, important, force) {
                        if (force) {
                            self.assertiveMessage = "";
                            self.politeMessage = "";
                        }
                        setTimeout(function () {
                            if (important) {
                                self.assertiveMessage = message;
                            }
                            else {
                                self.politeMessage = message;
                            }
                        }, force ? 300 : 0);
                    },
                    setBusy: function (busy) {
                        self.busy = busy;
                    },
                    clear: function () {
                        self.assertiveMessage = "";
                        self.politeMessage = "";
                    }
                };
            }
        })
    ], VueLive);
    return VueLive;
}(VueLiveInterface));

/* script */
            const __vue_script__$1 = VueLive;
            
/* template */
var __vue_render__$1 = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',[_vm._t("default"),_vm._v(" "),_c('div',{staticStyle:{"position":"absolute","height":"1px","width":"1px","margin":"-1px","clip":"rect(0 0 0 0)","overflow":"hidden"}},[_c('VueAria',{attrs:{"role":_vm.localRole,"aria":{ live: 'assertive', label: _vm.label, busy: _vm.busy }}},[_c('div',[_vm._v(_vm._s(_vm.assertiveMessage))])]),_vm._v(" "),_c('VueAria',{attrs:{"role":_vm.localRole,"aria":{ live: 'polite', label: _vm.label, busy: _vm.busy }}},[_c('div',[_vm._v(_vm._s(_vm.politeMessage))])])],1)],2)};
var __vue_staticRenderFns__$1 = [];

  /* style */
  const __vue_inject_styles__$1 = undefined;
  /* scoped */
  const __vue_scope_id__$1 = undefined;
  /* module identifier */
  const __vue_module_identifier__$1 = undefined;
  /* functional template */
  const __vue_is_functional_template__$1 = false;
  /* component normalizer */
  function __vue_normalize__$1(
    template, style, script,
    scope, functional, moduleIdentifier,
    createInjector, createInjectorSSR
  ) {
    const component = (typeof script === 'function' ? script.options : script) || {};

    // For security concerns, we use only base name in production mode.
    component.__file = "live.vue";

    if (!component.render) {
      component.render = template.render;
      component.staticRenderFns = template.staticRenderFns;
      component._compiled = true;

      if (functional) component.functional = true;
    }

    component._scopeId = scope;

    return component
  }
  /* style inject */
  
  /* style inject SSR */
  

  
  var live = __vue_normalize__$1(
    { render: __vue_render__$1, staticRenderFns: __vue_staticRenderFns__$1 },
    __vue_inject_styles__$1,
    __vue_script__$1,
    __vue_scope_id__$1,
    __vue_is_functional_template__$1,
    __vue_module_identifier__$1,
    undefined,
    undefined
  );

export { VueAria, directiveAria, focusTrap as VueFocusTrap, MixinKeyTravel, MixinId, MixinKeyShortcuts, live as VueLive };
